import java.io.*;
import java.util.*;

/**
 * ˤեΥꥹȤݻݥ饹
 */
public abstract class FileFinder {
    /**
     * ̤ΥեΥꥹ
     */
    private ArrayList<File> result;

    /**
     * Ĥե̤˴ޤ뤫Ƚꤹݥ᥽åɡ
     * @return	󤹤Ȥtrue
     */
    abstract boolean filter(File f);

    /**
     * ǥ쥯ȥõǤڤ뤫᥽åɡ
     * filter()η̤ȤΩư롣
     */
    abstract boolean prune(File f);

    //----------------------------------------------------------------------

    /**
     * 󥹥ȥ饯
     */
    public FileFinder() {
	result = new ArrayList<File>();
    }

    /**
     * ȥС»ܤ롣
     */
    protected void traverse(File f) {
	if(filter(f))
	    result.add(f);

	if(f.isDirectory()) {
	    if(prune(f))
		return; // õǤڤ
	    File[] arr = f.listFiles();
	    if(arr == null)
		return; // ǥ쥯ȥȤǤʤ
	    for(int i = 0; i < arr.length; i++)
		traverse(arr[i]);
	}
    }

    /**
     * ȥС»ܤƷ̤¸ʬȤ֤
     */
    public FileFinder find(File f) {
	traverse(f);
	return this;
    }

    /**
     * ̤List<File>ȤƼФ
     */
    public List<File> getList() {
	return result;
    }

    /**
     * ̤File[]ȤƼФ
     */
    public File[] getArray() {
	return result.toArray(new File[0]);
    }

    //----------------------------------------------------------------------

    /**
     * ƥȡ쥮顼եꥹȥåפ
     */
    public static void main(String argv[]) {
	FileFinder ff = new FileFinder() {
		boolean filter(File f) {
		    return f.canRead();
		}
		boolean prune(File f) {
		    return false;
		}
	    };
	Iterator<File> i = ff.find(new File(argv[0])).getList().iterator();
	while(i.hasNext()) {
	    File f = i.next();
	    System.out.println(f.getPath());
	}
    }
}
